;; Changelog:
;;
;; Version 1.1 - 2009-05-23: Update
;;   Reroutes INT21/08 to use INT16/00
;;   Fixes Omnicron Conspiracy as published by Imageworks
;;
;; Version 1.0 - 2005-06-19: Initial release
;;   Reroutes INT21/0B to use INT16/01
;;   Fixes Omnicron Conspiracy as published by Epyx

;; MAIN PROGRAM

;0100;Retrieve INT21 vector and store it
MOV AX,3521
INT 21
MOV [0166],BX
MOV [0168],ES

;010D;Set new INT21 vector
MOV AX,CS
MOV ES,AX
MOV DX,016A
MOV AX,2521
INT 21

;0119;Reduce memory used by this program to 64K (no need to move stack)
MOV BX,1000
MOV AX,4A00
INT 21

;0121;Set up parameter block
MOV [015C],CS
MOV [0160],CS
MOV [0164],CS

;012D;DOS function 4B - load and execute
MOV AX,4B00
MOV DX,014A
MOV BX,0158
INT 21

;0138;Restore old INT21 vector
CS:
MOV DX,[0166]
CS:
MOV AX,[0168]
MOV DS,AX
MOV AX,2521
INT 21

;0148;Quit
INT 20

;014A;Name of executable
DB 'OMNICRON.EXE',0,0
;0158;Parameter block
DW 0,0,0,0,0,0,0
;0166;Pointer to old handler
DW 0,0

;; INTERRUPT HANDLER

;016A;Enable interrupts
STI

;016B;Is this function 0B ("get input status")?
CMP AH,0B
JZ 017B

;170;Is this function 08 ("character input without echo")?
CMP AH,08
JZ 0188

;0175;It isn't -- call original handler
CS:
JMP FAR [0166]
IRET

;017B;This is function 0B -- call INT16/AH=01 (check for keystroke)
MOV AX,0100
INT 16
JZ 0185

;0182;Zero flag not set -- input available
MOV AL,FF
IRET

;0185;Zero flag set -- no input available
MOV AL,00
IRET

;0188;This is function 08 -- call INT16/AH=00 (get keystroke)
XOR AX,AX
INT 16
IRET
